import { MetadataAccessor } from '@loopback/context';
import { RestEndpoint, ControllerSpec } from '.';
import { ParameterObject, RequestBodyObject } from '@loopback/openapi-v3-types';
export declare namespace OAI3Keys {
    /**
     * Metadata key used to set or retrieve `@operation` metadata.
     */
    const METHODS_KEY: MetadataAccessor<Partial<RestEndpoint>, MethodDecorator>;
    /**
     * Metadata key used to set or retrieve `param` decorator metadata
     */
    const PARAMETERS_KEY: MetadataAccessor<ParameterObject, ParameterDecorator>;
    /**
     * Metadata key used to set or retrieve `@api` metadata
     */
    const CLASS_KEY: MetadataAccessor<ControllerSpec, ClassDecorator>;
    /**
     * Metadata key used to set or retrieve a controller spec
     */
    const CONTROLLER_SPEC_KEY: MetadataAccessor<ControllerSpec, ClassDecorator>;
    /**
     * Metadata key used to set or retrieve `@requestBody` metadata
     */
    const REQUEST_BODY_KEY: MetadataAccessor<RequestBodyObject, ParameterDecorator>;
}
